Jump to content

Создание эскиза на поверхности детали в SolidWorks API


Recommended Posts

NivaSol

Доброго времени суток. Возникла такая проблема пытаюсь создать эскиз на поверхности детали в VBA. Но не могу понять как это сделать. Можно через "SelectByRay", но каждый раз будут появляться новые координаты. Хотелось бы, что бы этот процесс происходил автономно без постоянного перекодирование. Я думал что это можно сделать через название поверхностей. То есть выбирается грань в солидворкс  их название при выдавливание каждый раз одинаковое одинаково, но не понял как это сделать.

Вот так я сделал:

 'Выбор эскиза
    swModel.SketchManager.InsertSketch False
    boolstatus = swModel.Extension.SelectByID2("Грань@Бобышка-вытянуть1", "BODYFEATURE", 2.59269323701414E-02, 1.71442592238754E-02, 0, False, 0, Nothing, 0)
    swModel.ClearSelection2 True

 

Весь код


Sub main()
 
 Dim swApp As SldWorks.SldWorks
 Dim boolstatus As Boolean
    Dim swModel As SldWorks.ModelDoc2
    Set swApp = Application.SldWorks
    Set swModel = swApp.ActiveDoc
    
    
    'Создание новой детали
    
    Set swModel = swApp.NewDocument("C:\ProgramData\SolidWorks\SOLIDWORKS 2019\templates\gost-part.prtdot", 0, 0, 0)
    
    'Выбор эскиза
    swModel.SketchManager.InsertSketch True
    boolstatus = swModel.Extension.SelectByID2("Спереди", "PLANE", 2.59269323701414E-02, 1.71442592238754E-02, 0, False, 0, Nothing, 0)
    swModel.ClearSelection2 True
    
    'Создание круга
    Dim skSegment As Object 'Объявление переменной круг
    Dim TxtDiametr1 As Long 'Объявление переменной диаметр
    TxtDiametr1 = 20
    Set skSegment = swModel.SketchManager.CreateCircle(0#, 0#, 0#, TxtDiametr1, 0, 0#)
    
    'Назначение размера
    swApp.SetUserPreferenceToggle swUserPreferenceToggle_e.swInputDimValOnCreate, False 'В приведенной выше строке кода мы отключаем поле ввода измерения перед добавлением измерения.
    swModel.AddDimension2 0, 0, 0.2 'AddDimension2 - Создает отображаемое измерение в указанном месте для выбранных объектов.
    
 
    
    'Выдавливание вала
    boolstatus = swModel.Extension.SelectByID2("Arc1@Эскиз1", "EXTSKETCHSEGMENT", 0, 0, 0, False, 0, Nothing, 0)
    Dim myFeature As Object
    Set myFeature = swModel.FeatureManager.FeatureExtrusion2(True, False, False, 0, 0, 0.2, 0.2, False, False, False, False, 1.74532925199433E-02, 1.74532925199433E-02, False, False, False, False, True, True, True, 0, 0, False)
    swModel.SelectionManager.EnableContourSelection = False
     
     
     'Выбор эскиза
    swModel.SketchManager.InsertSketch False
    boolstatus = swModel.Extension.SelectByID2("Грань@Бобышка-вытянуть1", "BODYFEATURE", 2.59269323701414E-02, 1.71442592238754E-02, 0, False, 0, Nothing, 0)
    swModel.ClearSelection2 True
End Sub

 Прошу помочь разобраться. Заранее спасибо.

Link to post
Share on other sites


UnPinned posts
brigval

Зайдите в Справку по API, введите в поиск InsertSketch. Найдите аналогичные примеры для VBA. Там все понятно.

Привыкайте сразу работать с этим хелпом. Там очень много полезного )

Link to post
Share on other sites
Kelny
23.06.2022 в 07:53, NivaSol сказал:

Возникла такая проблема пытаюсь создать эскиз на поверхности детали в VBA.

Возможно стоит описать всю задачу для которой требуется эскиз на поверхности.

 

23.06.2022 в 07:53, NivaSol сказал:

Можно через "SelectByRay", но каждый раз будут появляться новые координаты.

Так как ни крути, если создаются разные детали, то координаты будут разные, но если исходную деталь вы строити сами средствами API, то найти координату поверхности не сложно зная начальные координаты построение и вектор построения.

 

23.06.2022 в 07:53, NivaSol сказал:

Прошу помочь разобраться.

Если речь о построении каких-то стандартных компонентов, то возможно стоит создать базовые модели и для построения конечно детали лишь менять некоторые размеры и гасить/удалять лишнее. Такой подход позволит легко менять одну деталь на другую, т.к. идентификаторы поверхностей будут идентичны и будут самостоятельно переподципляться к имеющимся сопряжениям.

Так же возможно в этом случае обратить внимание на инструменты ToolBox, Driveworks, Configuration Publisher и тогда возможно для вашей задачи и вовсе подойдёт стандартный инструмент без программирования.

 

Ну и как посоветовали выше, ознакомьтесь со справкой, возможно там есть подходящий для вас пример:

https://help.solidworks.com/2010/english/api/sldworksapiprogguide/Welcome.htm

Link to post
Share on other sites
NivaSol
23.06.2022 в 14:59, brigval сказал:

Зайдите в Справку по API, введите в поиск InsertSketch. Найдите аналогичные примеры для VBA. Там все понятно.

Привыкайте сразу работать с этим хелпом. Там очень много полезного )

Этот вариант не подходит, так как требуется высокое знание англиканского и понимание, что как в SW называется. Нет не того и не другого. Я пользовался этим методом. Переводил все в гугле, искал в гугле и тому подобное, и как только появляются какие-то сложные задачи, нужно понимать название, что бы искать точно нужно.

Link to post
Share on other sites
brigval
27 минут назад, NivaSol сказал:

Этот вариант не подходит,

Как хотите.

Сначала вставка эскиза, потом выделение поверхности, потом сразу снятие выделения.

А в хелпе указана правильная последовательность действий.

Link to post
Share on other sites
NivaSol
1 час назад, Kelny сказал:

Возможно стоит описать всю задачу для которой требуется эскиз на поверхности.

 

Проблема такая на предприятие много валов и с них нужно постоянно снимать размеры. Приходится постоянно их чертить, по новой из-за того, что меняется количество ступеней, фасок, размеры длин и диаметров. Задача стоит в том, что бы пользователь просто вводил размеры и количество, и получал готовую модель и чертеж. Изначально я решил, что подобную задачу решить, через создание выдавливание и окружности, но проблема возникла на создании второй плоскости. Сейчас пробую через линии и повернутую бобышку, но проблема возникает с созданием фасок. 

В дальнейшем хотелось бы это интегрировать с экселем, что бы забивать на телефоне размеры, а потом просто переносить данные.

 

1 час назад, Kelny сказал:

Так как ни крути, если создаются разные детали, то координаты будут разные, но если исходную деталь вы строить сами средствами API, то найти координату поверхности не сложно зная начальные координаты построение и вектор построения.

Тут вы правы, но я новичок в этом деле и у меня код получается громоздкий. Вот я и подумал, что вдруг есть способ указать уже готовую поверхность.

Это можно понять потому факту, что я создаю не через цикл ступень, а забил двадцать окошек для того, что бы вводить длину, диаметр.

1 час назад, Kelny сказал:

Если речь о построении каких-то стандартных компонентов, то возможно стоит создать базовые модели и для построения конечно детали лишь менять некоторые размеры и гасить/удалять лишнее. Такой подход позволит легко менять одну деталь на другую, т.к. идентификаторы поверхностей будут идентичны и будут самостоятельно переподципляться к имеющимся сопряжениям.

Так же возможно в этом случае обратить внимание на инструменты ToolBox, Driveworks, Configuration Publisher и тогда возможно для вашей задачи и вовсе подойдёт стандартный инструмент без программирования.

Проблема в том, что  мне не известно, заранее количество ступеней. Мне не известны способы как регулировать количество ступеней в конфигураторе и ToolBox. Driveworks не попробовал, по тому, что не разобрался ещё с ним

Link to post
Share on other sites
Kelny
26 минут назад, NivaSol сказал:

Этот вариант не подходит, так как требуется высокое знание англиканского

Не требует, хотя справки по API на русском нет, но имеется множество онланй переводчиков в том числе встроенных в браузер, которые переводят всё на лету прямо на открытой странице.

Опять же сами примеры в справке имеют готовый код, но вы свой код ведь пишите без высого знания языка, а вам останется лишь скопировать и вставить всё или часть себе в программу.

 

27 минут назад, NivaSol сказал:

понимание, что как в SW называется.

Тоже не требуется ищите нужный инструмент в справке на русском языке, например, ЭСКИЗ:

https://help.solidworks.com/2010/russian/solidworks/sldworks/legacyhelp/sldworks/sw_sketch/sketch.htm

меняете в пути russian на english или смотрите прямо в пути и получаете название на языке программы SKETCH:

https://help.solidworks.com/2010/english/solidworks/sldworks/legacyhelp/sldworks/sw_sketch/sketch.htm

ищите данный инструмент по справке API, в том чилсе получая в выдаче примеры по использованию:

https://help.solidworks.com/SearchEx.aspx?query=SKETCH&version=2010&lang=english,enu&prod=api

 

 

Link to post
Share on other sites
NivaSol
Только что, Kelny сказал:

Не требует, хотя справки по API на русском нет, но имеется множество онланй переводчиков в том числе встроенных в браузер, которые переводят всё на лету прямо на открытой странице.

Опять же сами примеры в справке имеют готовый код, но вы свой код ведь пишите без высого знания языка, а вам останется лишь скопировать и вставить всё или часть себе в программу.

 

Тоже не требуется ищите нужный инструмент в справке на русском языке, например, ЭСКИЗ:

https://help.solidworks.com/2010/russian/solidworks/sldworks/legacyhelp/sldworks/sw_sketch/sketch.htm

меняете в пути russian на english или смотрите прямо в пути и получаете название на языке программы SKETCH:

https://help.solidworks.com/2010/english/solidworks/sldworks/legacyhelp/sldworks/sw_sketch/sketch.htm

ищите данный инструмент по справке API, в том чилсе получая в выдаче примеры по использованию:

https://help.solidworks.com/SearchEx.aspx?query=SKETCH&version=2010&lang=english,enu&prod=api

 

 

Я так делал, и нахожусь в том тупике, который описал выше.

 

Link to post
Share on other sites
Kelny
1 минуту назад, NivaSol сказал:

Я так делал, и нахожусь в том тупике, который описал выше.

Тупик создан непониманием, что же вы хотите сделать и на это вам указали:

7 минут назад, brigval сказал:

Сначала вставка эскиза, потом выделение поверхности, потом сразу снятие выделения.

 

23.06.2022 в 07:53, NivaSol сказал:

'Выбор эскиза

swModel.SketchManager.InsertSketch False

boolstatus = swModel.Extension.SelectByID2("Грань@Бобышка-вытянуть1", "BODYFEATURE", 2.59269323701414E-02, 1.71442592238754E-02, 0, False, 0, Nothing, 0)

swModel.ClearSelection2 True

@NivaSol Определитесь с задачей, потом будете искать решение.

Например в последнем куда логичнее выбрать поверхность, потом вставить эскиз (добавится на выбранную поверхность) и лишь потом снять выделение, если оно вообще требуется.

Link to post
Share on other sites

Join the conversation

You can post now and register later. If you have an account, sign in now to post with your account.
Note: Your post will require moderator approval before it will be visible.

Guest
Reply to this topic...

×   Pasted as rich text.   Paste as plain text instead

  Only 75 emoji are allowed.

×   Your link has been automatically embedded.   Display as a link instead

×   Your previous content has been restored.   Clear editor

×   You cannot paste images directly. Upload or insert images from URL.

  • Recently Browsing   0 members

    No registered users viewing this page.




  • Сообщения

    • Ильмир Галимов
      Добрый день. Смогли заменить подшипники? Где ремонтировали?
    • esergey
      ок , мануалы пока что по ссылке вечером приложу по ссылке справочные руководства для ТС 11.2 и ТС 11.5   
    • DuS
      Подскажите, как сделать чтобы была одна переменная и ею можно было пользоваться во всей сборке? Например: массив с шагом 500 и кол-вом 5, меняем эти значения и меняются все связанные массивы в сборке и в  подсборках входящих. Понимаю что можно завязать геометрией, но хочется через переменную.
    • AlexKaz
      Так прикол здесь такой: чтобы подобрать гайку надо знать нагрузку (усилие разрушения+ запас). Поэтому вопрос ТСа и про найти усилие... Нормальная экспериментальная работа. Привыкайте, мужики, что ГОСТами жизнь не ограничивается 
    • Fedor
      1. При отсутствии опытных определений модуля деформации  для сооружений II и III уровней ответственности допускается принимать .  - модуль деформации -го слоя грунта по ветви первичного нагружения  - деформации -го слоя грунта по ветви вторичного нагружения    <=      https://docs.cntd.ru/document/1200038307   
    • lexx174
      вы не совсем правы. ТЦ для мелкого частника избыточен дорог и попросту не нужен. ТЦ это не коробочный софт, его нужно настраивать и допиливать под каждое крупное предприятие с его спецификой.       А по делу - давайте начинать выкладывать полезные мануалы. Вы начнете. и кто-то еще подтянется.
    • westdm
      Сама конструкция гайки причина. Посмотрите ГОСТы на подобные нормативные соединения - ниппель-накидная гайка, там есть чертежи гаек, требования к ним и материалы из которых они изготавливаются. Конструкция гайки что на картинка очень странная - упорный бурт очень странный, маленькая площадь и наличие явных концентраторов вокруг. Это и причина. Гайка должна быть толще в этой части, без всяких углов - площадь контакта больше с плоскостью ниппеля, ну и радиусы в концентраторах, кроме того важен выбор материала, сталь 20? посмотрите хотя бы гост 16046 на накидные гайки, там сталь 45 идет минимум.
    • Maik812
      и что это такое ? спецификация и склад?  что там за наработки просто интересно !!!!!!!!!
    • esergey
      Любые наработки , такие же как и для крупного предприятия .
    • Борис Е
      Причина разрушения бурта, предположительно: 1. Недостаточная толщина бурта и стенок гайки. 2. Усталость металла. Меры исправления: 1. Увеличить толщину бурта и стенок гайки. 2. Эксплуатировать гайку не более установленного срока службы. 3. Обеспечить контролируемую затяжку, гайки, при сборке и ремонте.  
×
×
  • Create New...